%centroids3a.m
%This function should find the centroids of the B&W image that is input
%NOTE: Added error check for incorrect # of centroids
function C = centroids3a(A,b)
%Find all blobs and label
A=bwlabel(A);
%Initial conditions
k=1;
B=zeros(max(A(:)),6);
[i,j]=size(A);
found=[0 0];

%Scan for labeled blobs
for t=1:j
    for s=1:i
        if A(s,t)~=0
            B(A(s,t),4)=B(A(s,t),4)+1;      %Num of pixels in each centroid
            B(A(s,t),5)=B(A(s,t),5)+s;      %Sum of row values of centroid
            B(A(s,t),6)=B(A(s,t),6)+t;      %Sum of col values of centroid
            found=[A(s,t) 1];
        end
    end
    %Quick exit after b centroids have been found and a blank column
    if ((found(1)>=b+1)&(found(2)==0))
        fprintf('-');
        C=ccent3a(B,max(A(:)));
        if max(C(:,1))~=b
            C=zeros(max(C(:,1)),1);
        end
        return 
    end
    found(2)=0;
end

%Find centroid center
C=ccent3a(B,max(A(:)));
if max(C(:,1))~=b
    C=zeros(max(C(:,1)),1);
end
